﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace CAS_116109_Q3X8H3
{
    // Implements the CreationFilter interface		
    public class GridCreationFilter : IUIElementCreationFilter
    {                
        public GridCreationFilter()
        {
        }


        public bool BeforeCreateChildElements(Infragistics.Win.UIElement parent)  // Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        {
            // Don't need to do anything here
            return false;
        }

        public void AfterCreateChildElements(Infragistics.Win.UIElement parent) // Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        {
            if (parent is GroupByRowDescriptionUIElement)  //Check for the GroupByRowDescriptionUIElement
            {
                DependentTextUIElement aDependentTextUIElement = (DependentTextUIElement)parent.GetDescendant(typeof(DependentTextUIElement));
                CheckBoxUIElement aCheckBoxUIElement;
                                
                if (aDependentTextUIElement == null) return;

                //Create a New CheckBoxUIElement
                aCheckBoxUIElement = new CheckBoxUIElement(parent);

                UltraGridGroupByRow aGroupByRow = (UltraGridGroupByRow)aCheckBoxUIElement.GetAncestor(typeof(GroupByRowUIElement)).GetContext(typeof(UltraGridGroupByRow));

                if (aGroupByRow.Tag == null)
                    aGroupByRow.Tag = CheckState.Unchecked;
                else
                    aCheckBoxUIElement.CheckState = (CheckState)aGroupByRow.Tag;
                
                parent.ChildElements.Add(aCheckBoxUIElement);
                aCheckBoxUIElement.Rect = new Rectangle(parent.Rect.X + 3, parent.Rect.Y, parent.Rect.Height, parent.Rect.Height);
                aDependentTextUIElement.Rect = new Rectangle(aCheckBoxUIElement.Rect.Right + 3, aDependentTextUIElement.Rect.Y, parent.Rect.Width - aCheckBoxUIElement.Rect.Right, aDependentTextUIElement.Rect.Height);
            }
            else if (parent is RowSelectorUIElement)  //Check for the PreRowAreaUIElement
            {
                CheckBoxUIElement aCheckBoxUIElement;
                //Create a New CheckBoxUIElement
                aCheckBoxUIElement = new CheckBoxUIElement(parent);

                UltraGridRow aRow = (parent as RowSelectorUIElement).Row;

                if (aRow.Tag == null)
                    aRow.Tag = CheckState.Unchecked;
                else
                    aCheckBoxUIElement.CheckState = (CheckState)aRow.Tag;
                // Add the checkbox as a child element to the row selector
                parent.ChildElements.Add(aCheckBoxUIElement);
                aCheckBoxUIElement.Rect = new Rectangle(parent.Rect.X , parent.Rect.Y, parent.Rect.Height, parent.Rect.Height);
            }
        }
    }

}
